#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "likwid.h"
#include "timing.h"

#define N 2000000

void dummy(double*);

int main() {
  double w[N],a1[N],a2[N],a3[N],a4[N],a5[N],a6[N],a7[N],a8[N],a9[N],a10[N];
  int i, j,R,iter;
  double wct_start,wct_end,cput_start,cput_end,runtime,perf;

  LIKWID_MARKER_INIT;
#pragma omp parallel
{
  LIKWID_MARKER_THREADINIT;
}
#pragma omp parallel
{
  LIKWID_MARKER_START("Init");
#pragma omp for
  for(i=0; i<N ; ++i) {
    w[i]=0.0;
    a1[i]=a2[i]=a3[i]=a4[i]=a5[i]=a6[i]=a7[i]=a8[i]=a9[i]=a10[i]=1.0;
  }
 LIKWID_MARKER_STOP("Init");
}
  R=1;

  do {
    timing(&wct_start, &cput_start);
#pragma omp parallel 
{
      LIKWID_MARKER_START("Split");
}

    for(iter=0; iter<R; ++iter) {
#pragma omp parallel 
{
//      LIKWID_MARKER_START("Split");
#pragma omp for
      for(i=0; i<N ; ++i) {
	      w[i] = a1[i]+a2[i]+a3[i]+a4[i]+a5[i];
      }
#pragma omp for
      for(i=0; i<N ; ++i) {
	      w[i] += a6[i]+a7[i]+a8[i]+a9[i]+a10[i];
      }
//      LIKWID_MARKER_STOP("Split");
      if(w[2]<-1000.) dummy(&w[2]);
}
    }
    
#pragma omp parallel 
{
      LIKWID_MARKER_STOP("Split");
}
    timing(&wct_end, &cput_end);
    runtime = wct_end-wct_start;
    R += R;
  } while(runtime<5);
  
  R=R/2;
   
  perf = (double)R*N/runtime/1000000.; 
  printf("Split performance: %.0lf MIt/s, BW: %.2lf GB/s  It: %d\n",perf,perf*112.0/1000.,R);


 R=1;

  do {
    timing(&wct_start, &cput_start);
#pragma omp parallel 
{
      LIKWID_MARKER_START("Fused");
}

    for(iter=0; iter<R; ++iter) {
#pragma omp parallel 
{
//      LIKWID_MARKER_START("Fused");
#pragma omp for
      for(i=0; i<N ; ++i) {
          w[i] = a1[i]+a2[i]+a3[i]+a4[i]+a5[i]+a6[i]+a7[i]+a8[i]+a9[i]+a10[i];
      }
//      LIKWID_MARKER_STOP("Fused");
      if(w[2]<-1000.) dummy(&w[2]);
}
    }

#pragma omp parallel 
{
      LIKWID_MARKER_STOP("Fused");
}
    timing(&wct_end, &cput_end);
    runtime = wct_end-wct_start;
    R += R;
  } while(runtime<5);

  R=R/2;

  perf = (double)R*N/runtime/1000000.; 
  printf("Fused performance: %.0lf MIt/s, BW: %.2lf GB/s  It: %d\n",perf,perf*96.0/1000.,R);

  LIKWID_MARKER_CLOSE;
  
  return 0;
}
